commit 1ec35a90d4670e2296c8aba3cd1ccc397ac4c9ba
Author: freddy77 <freddy77>
Date:   Tue Dec 22 18:57:20 2009 +0000

    Better way to fix data_type for date

diff --git a/ChangeLog b/ChangeLog
index dd61f0a..3023f2e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Dec 22 20:01:16 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: Better way to fix data_type for date
+
 Tue Dec 22 20:00:18 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/common.c: Don't call SQLAllocEnv for ODBC 3
 
@@ -2016,4 +2019,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2914 2009/12/22 18:56:22 freddy77 Exp $
+$Id: ChangeLog,v 1.2915 2009/12/22 18:57:20 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index c2387f3..6b80a5b 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.522 2009/12/17 21:08:59 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.523 2009/12/22 18:57:20 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -88,7 +88,7 @@ static void odbc_col_setname(TDS_STMT * stmt, int colpos, const char *name);
 static SQLRETURN odbc_stat_execute(TDS_STMT * stmt, const char *begin, int nparams, ...);
 static SQLRETURN odbc_free_dynamic(TDS_STMT * stmt);
 static SQLRETURN odbc_free_cursor(TDS_STMT * stmt);
-static SQLSMALLINT odbc_swap_datetime_sql_type(SQLSMALLINT sql_type);
+static SQLSMALLINT odbc_fix_datetime_sql_type(SQLSMALLINT sql_type, SQLINTEGER odbc_version);
 static int odbc_process_tokens(TDS_STMT * stmt, unsigned flag);
 static int odbc_lock_statement(TDS_STMT* stmt);
 
@@ -3458,12 +3458,12 @@ odbc_fix_data_type_col(TDS_STMT *stmt, int idx)
 	switch (tds_get_conversion_type(colinfo->column_type, colinfo->column_size)) {
 	case SYBINT2: {
 		TDS_SMALLINT *data = (TDS_SMALLINT *) colinfo->column_data;
-		*data = odbc_swap_datetime_sql_type(*data);
+		*data = odbc_fix_datetime_sql_type(*data, stmt->dbc->env->attr.odbc_version);
 		}
 		break;
 	case SYBINT4: {
 		TDS_INT *data = (TDS_INT *) colinfo->column_data;
-		*data = odbc_swap_datetime_sql_type(*data);
+		*data = odbc_fix_datetime_sql_type(*data, stmt->dbc->env->attr.odbc_version);
 		}
 		break;
 	}
@@ -5761,26 +5761,20 @@ odbc_upper_column_names(TDS_STMT * stmt)
 }
 
 static SQLSMALLINT
-odbc_swap_datetime_sql_type(SQLSMALLINT sql_type)
+odbc_fix_datetime_sql_type(SQLSMALLINT sql_type, SQLINTEGER odbc_version)
 {
 	switch (sql_type) {
-	case SQL_TYPE_TIMESTAMP:
-		sql_type = SQL_TIMESTAMP;
-		break;
 	case SQL_TIMESTAMP:
-		sql_type = SQL_TYPE_TIMESTAMP;
-		break;
-	case SQL_TYPE_DATE:
-		sql_type = SQL_DATE;
+	case SQL_TYPE_TIMESTAMP:
+		sql_type = odbc_version != SQL_OV_ODBC2 ? SQL_TYPE_TIMESTAMP : SQL_TIMESTAMP;
 		break;
 	case SQL_DATE:
-		sql_type = SQL_TYPE_DATE;
-		break;
-	case SQL_TYPE_TIME:
-		sql_type = SQL_TIME;
+	case SQL_TYPE_DATE:
+		sql_type = odbc_version != SQL_OV_ODBC2 ? SQL_TYPE_DATE : SQL_DATE;
 		break;
 	case SQL_TIME:
-		sql_type = SQL_TYPE_TIME;
+	case SQL_TYPE_TIME:
+		sql_type = odbc_version != SQL_OV_ODBC2 ? SQL_TYPE_TIME : SQL_TIME;
 		break;
 	}
 	return sql_type;
@@ -5811,7 +5805,7 @@ SQLGetTypeInfo(SQLHSTMT hstmt, SQLSMALLINT fSqlType)
 	/* TODO ODBC3 convert type to ODBC version 2 (date) */
 	if (odbc3) {
 		if (TDS_IS_SYBASE(tds)) {
-			sprintf(sql, sql_templ, odbc_swap_datetime_sql_type(fSqlType));
+			sprintf(sql, sql_templ, odbc_fix_datetime_sql_type(fSqlType, SQL_OV_ODBC2));
 			stmt->special_row = ODBC_SPECIAL_GETTYPEINFO;
 		} else {
 			sprintf(sql, sql_templ, fSqlType);

